package ru.dbotthepony.mc.otm.core.math

import net.minecraft.core.Direction
import net.minecraft.world.level.block.state.BlockState
import net.minecraft.world.level.block.state.properties.EnumProperty
import ru.dbotthepony.mc.otm.core.get

internal inline val BlockState.rotationOne: BlockRotation get() = this[BlockRotationFreedom.ONE.property]
internal inline val BlockState.rotationTwo: BlockRotation get() = this[BlockRotationFreedom.TWO.property]
internal inline val BlockState.rotationThree: BlockRotation get() = this[BlockRotationFreedom.THREE.property]

internal inline val BlockState.facingOne: Direction get() = this[BlockRotationFreedom.ONE.property].primary
internal inline val BlockState.facingTwo: Direction get() = this[BlockRotationFreedom.TWO.property].primary
internal inline val BlockState.facingThree: Direction get() = this[BlockRotationFreedom.THREE.property].primary

enum class BlockRotationFreedom(vararg values: BlockRotation) {
	ONE(
		BlockRotation.NORTH,
		BlockRotation.SOUTH,
		BlockRotation.WEST,
		BlockRotation.EAST,
	),
	TWO(
		BlockRotation.DOWN,
		BlockRotation.UP,
		BlockRotation.NORTH,
		BlockRotation.SOUTH,
		BlockRotation.WEST,
		BlockRotation.EAST,
	),
	THREE(
		BlockRotation.DOWN,
		BlockRotation.UP,
		BlockRotation.NORTH,
		BlockRotation.SOUTH,
		BlockRotation.WEST,
		BlockRotation.EAST,
		BlockRotation.DOWN_NORTH,
		BlockRotation.DOWN_SOUTH,
		BlockRotation.DOWN_WEST,
		BlockRotation.DOWN_EAST,
		BlockRotation.UP_NORTH,
		BlockRotation.UP_SOUTH,
		BlockRotation.UP_WEST,
		BlockRotation.UP_EAST,
	);

	val possibleValues: Collection<BlockRotation> get() = property.possibleValues
	val property: EnumProperty<BlockRotation> = EnumProperty.create("facing", BlockRotation::class.java, *values)
}
